
Redmine - Defect #32793

Email address with Punycode top-level domain is not accepted

2020-01-13 06:28 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Accounts / authentication Estimated time: 0.00 hour

Target version: 4.1.1   

Resolution: Fixed Affected version:  

Description

Redmine does not accept email addresses that have Punycode top-level domain such as "jsmith@example.xn--80akhbyknj4f"

(example.ИСПЫТАНИЕ). There are already over 150 TLDs that begin with "xn--" in the real world (see 

https://www.icann.org/resources/pages/tlds-2012-02-25-en), so Redmine should accept those domains.

The attached relaxes the validation rule for an email address to accept top-level domains which begin with "xn--".

Related issues:

Related to Redmine - Feature #29208: Support email addresses with IDN (intern... Closed

Related to Redmine - Defect #6088: eMail in uncommon formats considered invalid Closed 2010-08-09

Associated revisions

Revision 19660 - 2020-04-05 11:55 - Jean-Philippe Lang

Email address with Punycode top-level domain is not accepted (#32793).

Patch by Go MAEDA.

Revision 19661 - 2020-04-05 12:00 - Jean-Philippe Lang

Adds a test for r19660 (#32793).

Revision 19667 - 2020-04-05 13:23 - Jean-Philippe Lang

Merged r19660 and r19661 to 4.1-stable (#32793).

History

#1 - 2020-01-13 06:29 - Go MAEDA

The issue can be fixed if the regular expression is changed as follows:

diff --git a/app/models/email_address.rb b/app/models/email_address.rb

index 46bca384a..dd0b30607 100644

--- a/app/models/email_address.rb

+++ b/app/models/email_address.rb

@@ -20,7 +20,7 @@

 class EmailAddress < ActiveRecord::Base

   include Redmine::SafeAttributes

-  EMAIL_REGEXP = /\A([^@\s]+)@((?:[-a-z0-9]+\.)+[a-z]{2,})\z/i

+  EMAIL_REGEXP = /\A([^@\s]+)@((?:[-a-z0-9]+\.)+(?:(?:xn--[-a-z0-9]+)|(?:[a-z]{2,})))\z/i

   belongs_to :user

#2 - 2020-01-13 06:30 - Go MAEDA

- Related to Feature #29208: Support email addresses with IDN (internationalized domain names) in user accounts added

#3 - 2020-01-15 09:46 - Go MAEDA

- Target version set to 4.1.1

Setting the target version to 4.1.1.

#4 - 2020-04-05 12:01 - Jean-Philippe Lang
- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Committed and test added, thanks.

#5 - 2020-04-05 13:23 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged.

#6 - 2022-01-13 15:02 - Go MAEDA

- Related to Defect #6088: eMail in uncommon formats considered invalid added

Powered by TCPDF (www.tcpdf.org)

2025-07-16 2/2

http://www.tcpdf.org

